# These are the imports used in these program
import urllib.parse
import json
from bs4 import BeautifulSoup as arrange
import requests
from prettytable import PrettyTable as pt
from datetime import date as dates
import sys


#Declaring Global Variables
City=None
Location=None
Forcast_Type=None
Place_Id=None
Date=None


# Fuction is used to get the placeId for the passed Location 
def Get_Place_id():


    #Telling the fuction that variables below are global not local variables
    global Place_Id


    #The url gives the json data for the entered location with placeId which is different for different location
    Api_url=url='https://api.weather.com/v3/location/search?apiKey=d522aa97197fd864d36b418f39ebb323&format=json&language=en-IN&locationType=locale&query=' + Location

    
    #check whether entered location by the user is proper or not. if not exit the program
    try:
        json_Data=requests.get(Api_url).json()
        Place_Id=json_Data['location']['placeId']
        Place_Id=str(Place_Id[0])
    except:
        print("Error: Please Enter the correct location")
        sys.exit(0)


    #Calling the function Decide_Forcast_Type() to decide which type of forcast type user want
    Decide_Forcast_Type()


# This Function will decide which type forcast type the user want accordingly appropriate fuction is called
def Decide_Forcast_Type():


    #Telling the fuction that variables below are global not local variables
    global Forcast_Type

    
    if Forcast_Type=='today':
        Todays_Forcast()
    elif Forcast_Type=="hourly":
        Hourly_Forcast()
    elif Forcast_Type=="5day":
        Five_Day_Forcast()
    elif Forcast_Type=="10day":
        Ten_Day_Forcast()
    elif Forcast_Type=="weekend":
        Weekend_Forcast()
    elif Forcast_Type=="monthly":
        Monthly_Forcast()
    else:
        print(""" Please enter the forcast type correctly

                                                          """)
        sys.exit()


#This Fuction will Return the Today's Forcast Details from Weather.com
def Todays_Forcast():


    #Telling the fuction that variables below are global not local variables
    global City,Location,Forcast_Type,Date,Place_ID
    

    #This url corresponds to actual url for entered location in the website with forcast type 'Today'
    Today_Forcast_url='https://weather.com/en-IN/weather/today/l/'+ Place_Id


    #Request is send to the server for the correponding url
    Web_Page=requests.get(Today_Forcast_url)


    #HTML souce code is obtained and stored in Page_Data variable
    Page_Data=arrange(Web_Page.content,"html.parser")


    #Below codes Finds the required data from the HTML source code and assign to corresponding variables
    Container=Page_Data.find("h1",{"class":"h4 today_nowcard-location"})
    City=Container.text
    Container=Page_Data.find("p",{"class":"today_nowcard-timestamp"}).text
    Time=Container
    Container=Page_Data.find("div",{"class":"today_nowcard-temp"}).text
    Temperature=Container
    Container=Page_Data.find("div",{"class":"today_nowcard-phrase"}).text
    Climate=Container


    # Table is created and data from variables are arranged in readable formation and output is displayed
    Table_Form=pt()
    Table_Form.field_names =["Results"," "]
    Table_Form.add_row(["City Name",City])
    Table_Form.add_row(["Time",Time])
    Table_Form.add_row(["Temperature",Temperature + "c"])
    Table_Form.add_row(["Climate",Climate])
    print(Table_Form)


#This Fuction will Return the Hourly Forcast Details from Weather.com
def Hourly_Forcast():


    #Telling the fuction that variables below are global not local variables
    global City,Location,Forcast_Type,Date,Place_ID
    

    #This url corresponds to actual url for entered location in the website with forcast type 'Hourly'
    Hourly_Forcast_url='https://weather.com/en-IN/weather/hourbyhour/l/' + Place_Id


    #Request is send to the server for the correponding url
    Web_Page=requests.get(Hourly_Forcast_url)


    #HTML souce code is obtained and stored in Page_Data variable
    Page_Data=arrange(Web_Page.content,"html.parser")
    

    #Initialize Table and assign field  names 
    Table_Form=pt()
    Table_Form.field_names =["Time","Temperature","Feels","Climate","Precipitation","Humidity"]


    #Below codes extract the required data from the HTML source code and assign to corresponding variables
    Containers=Page_Data.findAll("tr",{"class":"closed"})
    Container=Containers[0]
    for Container in Containers:
        Time=Container.find("div",{"class":"hourly-time"})
        Time=Time.span.text
        Climate=Container.find("td",{"class":"hidden-cell-sm description"})
        Climate=Climate.span.text
        Temperature=Container.find("td",{"class":"temp"})
        Temperature=Temperature.span.text
        Feels_Like=Container.find("td",{"class":"feels"})
        Feels_Like=Feels_Like.span.text
        Precipitation=Container.find("td",{"class":"precip"})
        Precipitation=Precipitation.text
        Humidity=Container.find("td",{"class":"humidity"})
        Humidity=Humidity.text

        #Adding elements in variables above to the table row wise each time when for loop is executed
        Table_Form.add_row([Time,Temperature,Feels_Like,Climate,Precipitation,Humidity])


    #Print the Output in table format 
    print(Table_Form)


#This Fuction will Return the 5-day Forcast Details from Weather.com
def Five_Day_Forcast():


    #Telling the fuction that variables below are global not local variables
    global City,Location,Forcast_Type,Date,Place_ID


    #This url corresponds to actual url for entered location in the website with forcast type '5-day'
    Five_Day_Forcast_url='https://weather.com/en-IN/weather/5day/l/' + Place_Id


    #Request is send to the server for the correponding url
    Web_Page=requests.get(Five_Day_Forcast_url)


    #HTML souce code is obtained and stored in Page_Data variable
    Page_Data=arrange(Web_Page.content,"html.parser")


    #Initialize Table and assign field  names 
    Table_Form=pt()
    Table_Form.field_names =["Day","Temperature Low/Hi","Precipitation","Humidity","Description"]


    #Below codes extract the required data from the HTML source code and assign to corresponding variables
    Containers=Page_Data.findAll("tr",{"class":"clickable closed"})
    Container=Containers[0]
    for Container in Containers:
        Day=Container.find("span",{"class":"date-time"})
        Day=Day.text
        Date=Container.find("span",{"class":"day-detail clearfix"})
        Date=Date.text
        Climate=Container.find("td",{"class":"description"})
        Climate=Climate.span.text
        Temperature=Container.find("td",{"class":"temp"})
        Temperature=Temperature.div.text

        
        #formating temperature data for better view
        try:
            index=Temperature.index('-')+ 2
            Temperature=Temperature[:index] + '/' + Temperature[index:]

        except:
            index=Temperature.index('°')+1
            Temperature=Temperature[:index]+ '/' + Temperature[index:]
            
        Humidity=Container.find("td",{"class":"humidity"})
        Humidity=Humidity.span.text
        Precipitation=Container.find("td",{"class":"precip"}).text
        Description=Container.find("td",{"class":"description"})
        Description=Description["title"]


        #Adding elements in variables above to the table row wise each time when for loop is executed
        Table_Form.add_row([Day + " " + Date,Temperature,Precipitation,Humidity,Description])


    #Print the Output in table format    
    print(Table_Form)


#This Fuction will Return the 10-day Forcast Details from Weather.com
def Ten_Day_Forcast():


    #Telling the fuction that variables below are global not local variables
    global City,Location,Forcast_Type,Date,Place_ID

    
    #This url corresponds to actual url for entered location in the website with forcast type '10-day'
    Ten_Day_Forcast_url='https://weather.com/en-IN/weather/tenday/l/' + Place_Id


    #Request is send to the server for the correponding url
    Web_Page=requests.get(Ten_Day_Forcast_url)


    #HTML souce code is obtained and stored in Page_Data variable
    Page_Data=arrange(Web_Page.content,"html.parser")


    #Initialize Table and assign field  names
    Table_Form=pt()
    Table_Form.field_names =["Day","Temperature Low/Hi","Precipitation","Humidity","Description"]


    #Below codes extract the required data from the HTML source code and assign to corresponding variables
    Containers=Page_Data.findAll("tr",{"class":"clickable closed"})
    Container=Containers[0]
    for Container in Containers:
        Day=Container.find("span",{"class":"date-time"})
        Day=Day.text
        Date=Container.find("span",{"class":"day-detail clearfix"})
        Date=Date.text
        Climate=Container.find("td",{"class":"description"})
        Climate=Climate.span.text
        Temperature=Container.find("td",{"class":"temp"})
        Temperature=Temperature.div.text


        #formating temperature data for better view
        try:
            index=Temperature.index('-')+ 2
            Temperature=Temperature[:index] + '/' + Temperature[index:]

        except:
            index=Temperature.index('°')+1
            Temperature=Temperature[:index]+ '/' + Temperature[index:]

            
        Humidity=Container.find("td",{"class":"humidity"})
        Humidity=Humidity.span.text
        Precipitation=Container.find("td",{"class":"precip"})
        Precipitation=Precipitation.text
        Description=Container.find("td",{"class":"description"})
        Description=Description["title"]


        #Adding elements in variables above to the table row wise each time when for loop is executed
        Table_Form.add_row([Day + " " + Date,Temperature,Precipitation,Humidity,Description])


    #Print the Output in table format
    print(Table_Form)


#This Fuction will Return the Weekend Forcast Details from Weather.com
def Weekend_Forcast():

    #Telling the fuction that variables below are global not local variables
    global City,Location,Forcast_Type,Date,Place_ID

    
    #This url corresponds to actual url for entered location in the website with forcast type 'Weekend'
    Weekend_Forcast_url='https://weather.com/en-IN/weather/weekend/l/' + Place_Id


    #Request is send to the server for the correponding url
    Web_Page=requests.get(Weekend_Forcast_url)


    #HTML souce code is obtained and stored in Page_Data variable
    Page_Data=arrange(Web_Page.content,"html.parser")


    #Initialize Table and assign field  names
    Table_Form=pt()
    Table_Form.field_names =["Day","Temperature Hi/Low","Climate","Precipitation"]


    #Below codes extract the required data from the HTML source code and assign to corresponding variables
    Week_1=Page_Data.find("h2",{"class":"h4 this-weekend"}).text
    Week_2=Page_Data.find("h2",{"class":"h4 next-weekend"}).text
    Containers=Page_Data.findAll("section",{"class":"ls-mod"})
    Container=Containers[0]
    Table_Form.add_row([Week_1,"","",""])
    global x
    x=0
    for Container in Containers:
        if(x==1):
            Table_Form.add_row([Week_2,"","",""])
        Containers=Container.findAll("section",{"class":"wxcard wxcard-summary summary-view is24Hour"})
        Container=Containers[0]
        for Container in Containers:
            Day=Container.find("header",{"class":"heading weather-cell"})
            Day=Day.text
            Temperature=Container.find("p",{"class":"temp temp-12 weather-cell"}).text
            index=Temperature.index('°')+1
            Temperature=Temperature[:index]+ "/" + Temperature[index:]
            Temperature=Temperature.replace("C","")
            Climate=Container.find("h3",{"class":"weather-phrase weather-cell"})
            Climate=Climate.text.replace("\n","")
            Precipitation=Container.find("p",{"class":"precip weather-cell"})
            Precipitation=Precipitation.span.text


            #Adding elements in variables above to the table row wise each time when for loop is executed
            Table_Form.add_row([Day,Temperature,Climate,Precipitation])

            
            x=1
        Table_Form.add_row(["","","",""])


    #print output in the table format
    print(Table_Form)


#This Fuction will Return the Monthly Forcast Details from Weather.com
def Monthly_Forcast():


    #Telling the fuction that variables below are global not local variables
    global City,Location,Forcast_Type,Date,Place_ID


    #This url corresponds to actual url for entered location in the website with forcast type 'Monthly'
    Monthly_Forcast_url='https://weather.com/en-IN/weather/monthly/l/' + Place_Id


    #Request is send to the server for the correponding url
    Web_Page=requests.get(Monthly_Forcast_url)


    #HTML souce code is obtained and stored in Page_Data variable
    Page_Data=arrange(Web_Page.content,"html.parser")


    #Initialize Table and assign field  names
    Table_Form=pt()
    Table_Form.field_names=["Date","High Temperature","Low Temperature"]


    #Below codes extract the required data from the HTML source code and assign to corresponding variables
    Containers=Page_Data.findAll("div",{"class":"dayCell"})
    Container=Containers[0]
    Current_Date_time=Page_Data.find("select",{"aria-label":"Calendar Month Picker"})
    Current_Date_time=Current_Date_time["value"]
    print("Current Date= " + Current_Date_time[:10] +" Current Time= " + Current_Date_time[11:])
    for Container in Containers:
        Day=Container.find("div",{"class":"date"})
        Day=Day.text
        Temperature_High=Container.find("div",{"class":"temp hi"})
        Temperature_High=Temperature_High.span.text
        Temperature_Low=Container.find("div",{"class":"temp low"})
        Temperature_Low=Temperature_Low.span.text


        #Adding elements in variables above to the table row wise each time when for loop is executed
        Table_Form.add_row([Day,Temperature_High,Temperature_Low])


    #print output in the table format
    print(Table_Form)



# This Function prints the user inputs or Default values to screen
def Print_User_Inputs():

    #Telling the fuction that variables below are global not local variables
    global City,Location,Forcast_Type,Date

    
    print("Entered City:",Location + " ","Date:",Date," ","Type of Forcast:",Forcast_Type)


    #calling the Fuction Get_Place_id() to get the place_Id for entered Location
    Get_Place_id()



# This Fuction checks wheather given input by user is null and set defaults values for it
def Set_Default_Values_To_input():

    #Telling the fuction that variables below are global not local variables
    global City,Location,Forcast_Type,Date

    
    if Location=='':
    	print("Please Enter the location correctly it can't be NULL")
    	sys.exit()
    elif Forcast_Type=='':
    	Forcast_Type='today'
    if Date=='':
    	Date=str(dates.today())

    
    #Calling the Fuction Print_User_Inputs() to print the user inputs to the screen
    Print_User_Inputs()


#This function converts input data into required format
def Input_Data_Formating():

    #Telling the fuction that variables below are global not local variables
    global City,Location,Forcast_Type,Date

    
    Date=Date.replace('/','-').replace(' ','-')
    Forcast_Type=Forcast_Type.lower()
    Forcast_Type=Forcast_Type.replace('-','')


    #Calling the Function Set_Default_To_Input() for setting input to default values if input by user is null
    Set_Default_Values_To_input()


# This function takes input from the user 
def Get_User_Inputs():

    #Telling the fuction that variables below are global not local variables
    global City,Location,Forcast_Type,Date

    
    print("     ! Weather_com Web scraping ! ")
    print('Please make the size of window maximum for better view of output results')
    Location=input("Enter the Location: ")
    Date=input("Enter the date yyyy/mm/dd (by default currentday): ")
    print("Type of Forcasts------- Today    Hourly     5-day    10-day    Weekend    Monthly")
    Forcast_Type=input("Enter the Forcat type: ")
    print("Please wait don't close or interrupt the process (depend on network)....")


    # Calling the function Input_Data_Formating() for formating input data
    Input_Data_Formating()

    
# Calling the fuction Get_User_Inputs() where input is taken from the user and this is starting point of program
Get_User_Inputs()
